VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'List of objects clsNode, provides main functionality

Option Explicit

Public oHead As clsNode 'Contains pointer to the first
Public oTail As clsNode 'Contains pointer to the last
Public numberOfNodes As Integer 'Number of nodes in the list


'Find an element by index
'Returns a node as an object
Public Function SearchByIndex(ByVal theIndex As Integer) As clsNode
    Dim returnNode As clsNode
    Dim Counter As Integer
    Set returnNode = oHead 'Start position
    'TheIndex should be>0
    If theIndex < 0 Then
        Set SearchByIndex = Nothing
        Exit Function
    End If
    'Loop until required index is reached
    For Counter = 1 To theIndex
        'Stop if the tail is reached
        If returnNode.getNext Is oTail Then
            'And return nothing
            Set SearchByIndex = Nothing
            Exit Function
        End If
        'Increase counter
        Set returnNode = returnNode.getNext
    Next Counter
    'Return the result
    Set SearchByIndex = returnNode
End Function

'Find an element by tetx, only first occurence
'Returns the index of the node
'If not found returns -1
Public Function SearchByText(ByVal theText As String) As Integer
    Dim nodeCounter As clsNode
    Dim returnIndex As Integer
    Set nodeCounter = oHead 'Start position
    returnIndex = 0
    'Loop until the tail is reached
    Do While Not nodeCounter.getNext Is oTail
        'Increase counter
        Set nodeCounter = nodeCounter.getNext
        returnIndex = returnIndex + 1
        If nodeCounter.getData = theText Then
            'Found. Return the result
            SearchByText = returnIndex
            Exit Function
        End If
    Loop
    'Not found
    SearchByText = -1
End Function

'Add an element to start
Public Sub addAnElementToStart(theData As String)
    Dim oTemp As clsNode 'Temporary node
    Set oTemp = New clsNode
    
    oTemp.letData = theData 'Initialize data
    'Point it forward where the head is pointing
    Set oTemp.setNext = oHead.getNext
    'And backward to the head
    Set oTemp.setPrev = oHead
    'Point backward ex-first to the new
    Set oHead.getNext.setPrev = oTemp
    'Point forward head to new
    Set oHead.setNext = oTemp
    Set oTemp = Nothing 'Delete temporary variable
    numberOfNodes = numberOfNodes + 1 'Increase number of nodes
End Sub

'Add an element to end
Public Sub addAnElementToEnd(theData As String)
    Dim oTemp As clsNode
    Set oTemp = New clsNode 'Temporary node
    
    oTemp.letData = theData 'Initialize data
    'The ex-last will now point forward to a new last
    Set oTail.getPrev.setNext = oTemp
    'New last will now point backward to the ex-last
    Set oTemp.setPrev = oTail.getPrev
    'Set new point forward to tail
    Set oTemp.setNext = oTail
    'Set tail point backward to new
    Set oTail.setPrev = oTemp
    Set oTemp = Nothing 'Delete temporary variable
    numberOfNodes = numberOfNodes + 1 'Increase number of nodes
End Sub

' Class constructor
Private Sub Class_Initialize()
    Set oHead = New clsNode 'Even empty list must have this
    Set oTail = New clsNode
    
    oHead.letData = "HEAD!" 'For debugging purposes
    oTail.letData = "TAIL!"
        
    'In empty list head points to tail and tail points to head
    Set oHead.setNext = oTail
    Set oHead.setPrev = Nothing 'Never changed
    Set oTail.setNext = Nothing 'Never changed
    Set oTail.setPrev = oHead
    numberOfNodes = 0 'Set number of nodes
End Sub

'Empty the list
Public Sub Clear()
    'Delete first element of the list
    Set oHead.getNext.setNext = Nothing
    'In empty list head points to tail and tail points to head
    Set oHead.setNext = oTail
    Set oTail.setPrev = oHead
    numberOfNodes = 0 'Set number of nodes
End Sub

'Delete one node
Public Function deleteNode(theNode As clsNode) As Boolean
    'Nothing to delete
    If theNode Is Nothing Then
        deleteNode = False
        Exit Function
    End If
    'Don't delete head and tail
    If theNode.getNext Is Nothing Or theNode.getPrev Is Nothing Then
        deleteNode = False
        Exit Function
    End If
    'The node before deleted will point to next node forward
    Set theNode.getPrev.setNext = theNode.getNext
    'And the node after the deleted will point to the node
    'before the deleted backward
    Set theNode.getNext.setPrev = theNode.getPrev
    'Delete isToBeDeleted
    Set theNode = Nothing
    deleteNode = True 'Delete successful
    numberOfNodes = numberOfNodes - 1 'Decrease number of nodes
End Function

'Move node from index From to index Where
Public Function Relocate(nodeFrom As clsNode, nodeWhere As clsNode) As Boolean
    'Do not relocate
    '1) to and from nowhere,
    '2) head and tail
    '3) when to and from are the same
    
    If nodeFrom Is Nothing Or nodeWhere Is Nothing Or _
        nodeFrom Is oHead Or nodeFrom Is oTail Or _
        nodeFrom Is nodeWhere Then
        Relocate = False
        Exit Function
    End If
    
    'Special case: to and from are adjacent (neighbours)
    If nodeFrom.getNext Is nodeWhere Then
        Dim theNodeBefore As clsNode
        Dim theNodeAfter As clsNode
 
        Set theNodeBefore = nodeFrom.getPrev
        Set theNodeAfter = nodeWhere.getNext
        
        Set theNodeBefore.setNext = nodeWhere
        Set nodeFrom.setPrev = nodeWhere
        Set nodeWhere.setPrev = theNodeBefore
        Set nodeFrom.setNext = theNodeAfter
        Set theNodeAfter.setPrev = nodeFrom
        Set nodeWhere.setNext = nodeFrom
    Else
        'Normal case
        Set nodeFrom.getPrev.setNext = nodeFrom.getNext
        Set nodeFrom.setPrev = nodeWhere
        Set nodeFrom.getNext.setPrev = nodeFrom.getPrev
        Set nodeFrom.setNext = nodeWhere.getNext
    
        Set nodeWhere.getNext.setPrev = nodeFrom
        Set nodeWhere.setNext = nodeFrom
    End If
    Relocate = True 'Successful relocation
End Function
